; =========================
;  Created by Spce Fractal
; =========================
;
;
; Sound Even Playing for SDK v1b10
;
; == Please Note: ==
; It use Movie to play sound only sample and not sound.
; Otherwice it would crash on Visual Basic 6 on exit.
;
; I also use Movie commands, not Sound commands. Movie
; Command use MediaPlayer to play sound, so MP3 files
; can been used. 
;

Global Result$=""
Global LastDir$=""
Global init=0
Global LastPlay=0
Global pointer=0
Global CommandString$
Global CommandStringLocal$
Global EventString$

Global ThreadDo=0
Global ThreadOK=0
Global ThreadID=0

Structure commandTable
 EVENT$
 sampleFile$
 Sound.l
 Found.l
EndStructure 

Global NewList EVENT.commandTable()

Procedure Event_Create(Value$)
   If UCase(Left(Value$, 6))="STATUS"
      ProcedureReturn
   EndIf
   
   ForEach EVENT()
      If EVENT()\EVENT$=Value$
        EVENT()\FOUND=1
        ProcedureReturn
      EndIf
   Next
   AddElement(EVENT())
   EVENT()\EVENT$=Value$
   EVENT()\FOUND=1
EndProcedure


Procedure.s SampleName(Name$)
  ForEach EVENT()
    If Name$=EVENT()\EVENT$
      If EVENT()\SampleFile$=""
        ProcedureReturn "No File"
      EndIf
      ProcedureReturn EVENT()\SampleFile$
    EndIf
  Next
EndProcedure

Procedure.l Save()
  Result$ = ProgramFilename()
  Path$ = GetPathPart(result$)
  If CreateFile(0, Path$+"/SoundEvent.ini")   
    WriteString(0, LastDir$+Chr(13))
    ForEach EVENT()
      WriteString(0, EVENT()\EVENT$+Chr(13))
      WriteString(0, EVENT()\SampleFile$+Chr(13))
    Next
    WriteString(0, "#END#"+Chr(13))
    CloseFile(0)

  EndIf
EndProcedure

Procedure ThreadRunning()
  ; all playing is doing it a thread

  InitMovie()
  ThreadOK=1
  
  Repeat
    ; Load a Sample
    If ThreadDo=1
      EVENT()\sound=LoadMovie(#PB_Any, Event()\sampleFile$)
      ThreadOK=1
      ThreadDo=0
    
    ; Shutdown a sample
    ElseIf ThreadDo=2
      ForEach EVENT()
        If EVENT()\Sound<>0
          StopMovie(EVENT()\Sound)
        EndIf
        FreeMovie(EVENT()\Sound)
      Next
      ThreadOK=1
      ThreadDo=0
      Break
      
    ; Play a Sample
    ElseIf ThreadDo=3
      PlayMovie(Event()\Sound, ScreenID())
      LastPlay=Event()\Sound
      ThreadDo=0   
    ElseIf ThreadDo=4
      ; Stop the sample
      If IsMovie(LastPlay)
        StopMovie(LastPlay)
      EndIf
      ThreadDo=0
    EndIf
    Delay(1)
  Until OK=1
EndProcedure

ProcedureDLL.l Juke_Command(Command.l, value.l)
  CommandString$=PeekS(Command)
  CommandStringLocal$=CommandString$
  CommandStringLocal$=UCase(CommandStringLocal$)
  CommandStringLocal$=Trim(CommandStringLocal$)
  
  EventString$=PeekS(Value)
  EventStringLocal$=EventString$
  EventStringLocal$=Trim(EventStringLocal$)
 
  ; JUKE_KEY_EVENT_CREATE was used before beta 10. Hence it listen to both commands, due to the renamed command
  If CommandStringLocal$="JUKE_KEY_EVENT_CREATE" Or CommandStringLocal$="JUKE_PLUGIN_EVENT_CREATE"
     Event_Create(EventStringLocal$)
  
  ElseIf CommandStringLocal$="JUKE_KEY_EVENT_SEND" Or CommandStringLocal$="JUKE_PLUGIN_EVENT_SEND"
      EVENT$=StringField(EventStringLocal$, 1, "|")
      EVENT$=Trim(EVENT$)

      ForEach EVENT()
       If EVENT$=EVENT()\EVENT$
          If EVENT()\Sound>0
            ThreadID=3
            Repeat
            Until ThreadOK=1
            ThreadOK=0
            Break
          EndIf
        EndIf
      Next  
  EndIf
  
  ProcedureReturn 0
EndProcedure


ProcedureDLL.l Juke_Configure(winID.l)
   
  ; coult number of commands
  Count=0
  ForEach EVENT()
    count=count+1
  Next
  
  ; add a test command if there is no commands
  If count=0
    Event_Create("KEY_EVENT_TEST")
  EndIf

  If IsWindow(winID)=0
    winID=0
  EndIf
  
  window = OpenWindow(0 , 0, 0, 475, 220, "Sound Event by Space Fractal", #PB_Window_ScreenCentered|#PB_Window_TitleBar, winID)
  If CreateGadgetList(WindowID(0))
    X=10 : Y=10
    TextGadget(1, X, Y+4, 200, 25, "Choice a KEY_EVENT to effect a sound:") 
    
    ComboBoxGadget(2, X+200, Y, 250, 160, #PB_ComboBox_UpperCase)
    
    Position=-2
    ForEach EVENT()

      Position=Position+1
      AddGadgetItem(2, -1, EVENT()\EVENT$)    
    Next
    SetGadgetState(2,0)
    Y=Y+40
    
    Frame3DGadget(#PB_Any, 10, Y, WindowWidth(0)-20, 100, "")
    X=X+25 : Y=Y+20
 
    
    TextGadget(9, X, Y+3, 70, 25, "Filename:") 
    File=StringGadget(4, X+50, Y, 350, 20, SampleName(GetGadgetText(2)), #PB_String_ReadOnly)
    Y=Y+40
    
    BROWSER=ButtonGadget(5, 40, Y, 100, 20, "BROWSE")
    PLAY=ButtonGadget(6, WindowWidth(0)/2+25, Y, 80, 20, "PLAY")
    STOP=ButtonGadget(7, WindowWidth(0)/2+125, Y, 80, 20, "STOP")

    
    DONE=ButtonGadget(10, WindowWidth(0)/2-50, WindowHeight(0)-40, 100, 25, "DONE")
    
    Repeat
      EventID = WaitWindowEvent()
    
      If EventID = #PB_Event_Gadget
        Select EventGadget()
          Case 2
              EVENT$=GetGadgetText(2)
              SetGadgetText(4, SampleName(EVENT$))
          Case 5
              EVENT$=GetGadgetText(2)
              File$=OpenFileRequester("Choice a OGG or WAV", LastDir$, "Wave Or OGG files|*.wav;*.ogg",0)


              If LCase(Right(File$, 3))<>"ogg" And LCase(Right(File$, 3))<>"wav" And LCase(Right(File$, 3))<>"mp3"
                If File$<>"" 
                  MessageRequester("Error", "This file is Not a ogg Or wav file", #PB_MessageRequester_Ok)
                EndIf
              Else
                LastDir$=GetPathPart(File$)
                ForEach EVENT()
                  If EVENT$=EVENT()\EVENT$

                    If EVENT()\Sound<>0
                      FreeMovie(EVENT()\Sound)
                    EndIf
                    
                    OK=LoadMovie(#PB_Any, File$)
                    If OK<>0
                      EVENT()\sampleFile$=File$
                      EVENT()\Sound=OK
                    Else
                      If File$<>""
                        MessageRequester("Error", "This file could NOT been open", #PB_MessageRequester_Ok)
                      Else
                        EVENT()\sampleFile$=""
                      EndIf
                    EndIf

                    Break

                  EndIf
                Next
                SetGadgetText(4, SampleName(EVENT$))
              EndIf
              
          Case 6
            EVENT$=GetGadgetText(2)
            ForEach EVENT()
              If EVENT$=EVENT()\EVENT$
                ThreadDo=3
                Delay(2)
              EndIf
            Next
          
          Case 7
            If LastPlay>0
                StopMovie(LastPlay)
              LastPlay=0
            EndIf
          Case 10
            Break
        EndSelect
      EndIf
    Until EventID = #PB_Event_CloseWindow
  EndIf
  CloseWindow(0)
  Save()
  ProcedureReturn 1
EndProcedure



ProcedureDLL.l Juke_GetPluginInfo(value.l)
    result$="Sound Event Plugin|Space Fractal|for SDK v1b10|Play a sample when a KEY_EVENT is used"+Chr(0)
    pointer=@result$
    ProcedureReturn pointer
EndProcedure

ProcedureDLL.l Juke_Initialize(value.l)
  If init=1
    ProcedureReturn
  EndIf

  ThreadID=CreateThread(@ThreadRunning(), 0)

  Repeat
    Delay(1)
  Until ThreadOK=1
  ThreadOK=0
  
  
  Result$ = ProgramFilename()
  Path$ = GetPathPart(result$)
  
  If ReadFile(0, Path$+"SoundEvent.ini")
    LastDir$=ReadString(0)

    Repeat
      If Eof(0)
        Break
      EndIf
      EVENT$=ReadString(0)
      EVENT$=Trim(EVENT$)
      If EVENT$="" Or Eof(0) Or EVENT$="#END#"
        Break
      EndIf
      SampleFile$=ReadString(0)
      AddElement(EVENT())
      EVENT()\EVENT$=EVENT$
      EVENT()\SampleFile$=SampleFile$
      
      ThreadDo=1
      ThreadOK=0
      Repeat
        Delay(1)
      Until ThreadOK=1
      ThreadOK=0
          
      If EVENT()\Sound.l=0
        EVENT()\SampleFile$=""
      EndIf
    Until Eof(0)
    CloseFile(0)
  EndIf

  init=1
  ProcedureReturn 1
EndProcedure



ProcedureDLL.l Juke_Shutdown(value.l)
  ; unload any song in the thread
  ThreadDo=2
  Repeat
    Delay(1)
  Until ThreadOK=1
  KillThread(ThreadID)
  
  ProcedureReturn 1
EndProcedure
; IDE Options = PureBasic 4.10 (Windows - x86)
; ExecutableFormat = Shared Dll
; CursorPosition = 39
; FirstLine = 22
; Folding = --
; EnableThread
; EnableXP
; EnableOnError
; Executable = SoundEvent.dll
; CPU = 1